/*	
 *	clip65c.h
 *
 *	P/ECE MOS6502 Emulator ()
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Fri Jan 28 03:55:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_65C_H__
#define __CLIP_65C_H__

/****************************************************************************
 *	
 ****************************************************************************/

/* spM6502 CPU\̂łB
 *
 * [note]
 *	* nztB[h́APSR(N,Z)\܂B
 *	- nz[7:0]0ȂPSR(Z)=1AȂPSR(Z)=0łB
 *	- nz[15]܂nz[7]1ȂPSR(N)=1AȂPSR(N)=0łB
 *	* ̂悤ȎdlɂŔABIT߂̃tOωɑΉ邽߂łB
 *	- M6502 CPÛقƂǂ̖߂́A߂̎sʂPSR(N,Z)ɔf܂B
 *	  ̏邽߂ɂ́APSR(N,Z)\1bytetB[hpӂA
 *	  ߂̎sʂ̃tB[hɊi[悤ɂ΂̂łB
 *	  1bytetB[hŜ0ۂPSR(Z)𔻒肵Abit7PSR(N)𔻒肵܂B
 *	  ̕@ł́APSR(Z)=1PSR(N)=1AƂԂ\Ƃ͂ł܂B
 *	  1bytetB[hŜ0ɂ܂܁Abit71ɂ邱Ƃ͂łȂłB
 *	- قƂǂ̖߂͂łȂ̂łABIT߂ɂȂ܂B
 *	  BIT߂AWX^ƃlAndʂPSR(Z)ɔfA
 *	  l̂܂܂̒lPSR(N)ɔf܂B
 *	  ƂAWX^̒l$00Ńl$FF肷ƁA
 *	  PSR(Z)=1PSR(N)=1ƂʂL蓾̂łB
 *	  BIT߂ɑΉɂ́APSR(N,Z)\1bytetB[hł͕s[łB
 *	  ȂBIT߂̂߂ɁȂ̂قƂǂ̖߂PSR(N,Z)
 *	  xȂ͔̂ƂłB
 *	- ŁA2bytetB[hgA݂̕@l܂B
 *	  bit7:00ۂPSR(Z)𔻒f̂́AOo̕@ƓłB
 *	  ܂Abit70ۂPSR(N)𔻒f̂AOo̕@ƓłB
 *	  ɉāAbit70łĂAbit151ȂPSR(N)=1Ɣf܂B
 *	  PSR(Z)=1PSR(N)=1\ɂ́A$8000(bit14:8͔C)ŕ\ł܂B
 *	  ƂAWX^̒l$00Ńl$FFBIT߂sꍇ́A
 *	  2bytetB[h̒l$FF00ƂȂAPSR(Z)=1APSR(N)=1Ӗ܂B
 *	- bit15ɂPSR(N)=1\ĝ́ABIT߂ƁA1byte PSRlunpack݂̂łB
 *	  ȊȌꍇ́Abit7:0gAbit15:8NA܂B
 *	  1bytetB[hgꍇɊrׂāAbit15:8NA菇̒ǉ͕svłB
 *	  ߂̎sʂ̒l͕1bytelɂȂĂ͂A
 *	  Pɓ]邾bit15:8NAł邩łB
 *		ld.w %A, %data
 *		ret.d
 *		ld.w %NZ, %A		; bit7:0PSR(N,Z)ݒ肵Abit15:8NA
 *	  %NZ1bytetB[hƂĂꍇƁAS萔ōς݂܂B
 *	  ʂ1bytełȂꍇ́Ald.ubg1߂bit15:8NAł܂B
 *		ld.w [%CPU+X], %data
 *		ld.ub %NZ, %data	; bit7:0PSR(N,Z)ݒ肵Abit15:8NA
 *		ret.d
 *	  ld.ub͒xXbgɓȂ̂ŁAld.wɊrׂĂ킸ɒxȂ܂B
 */
typedef struct _M6502CPU {
	unsigned short ca;		/* + 0,2 -------C AAAAAAAA */
	unsigned short nz;		/* + 2,2 N------- NZZZZZZZ */
	unsigned char bdi;		/* + 4,1          001BDI00 */
	unsigned char v;		/* + 5,1          V------- */
	unsigned char x;		/* + 6,1          XXXXXXXX */
	unsigned char y;		/* + 7,1          YYYYYYYY */
	unsigned char* pc;		/* + 8,4 &mem[PC]          */
	unsigned char* sp;		/* +12,4 &mem[$100|SP]     */
	//
	int flags;			/* +16,4          ------IW */
	int cycle;			/* +20,4 cCycle         */
	void* read;			/* +24,4 ǂݏo[` */
	void* write;			/* +28,4 ݃[` */
} M6502CPU;				/* =32   */

/* M6502CPU.flags */
#define M6502CPU_WAI	(1 << 0)	/* WAI 0=ʏ,1=~ */
#define M6502CPU_IRQ	(1 << 1)	/* IRQۗ 0=,1=L */

/* WX^ݒEQƗp̍\̂łB
 * [note]
 *	* M6502CPU\̂́A6502̃WX^Zbĝ܂܂̍\ł͂Ȃ̂ŁA
 *	  vO烌WX^ݒE擾ꍇɁA∵Â炢łB
 *	  ̂܂܂̒lŐݒE擾ł悤AM6502REG\̂pӂ܂B
 *	  m6502reg_put()gāAWX^lݒ肵܂B
 *	  m6502reg_get()gāAWX^l擾܂B
 */
typedef struct _M6502REG {
	unsigned char  a;		/* +0, 1 */
	unsigned char  x;		/* +1, 1 */
	unsigned char  y;		/* +2, 1 */
	/* ( padding ) */		/* +3, 1 */
	unsigned short pc;		/* +4, 2 */
	unsigned char  sp;		/* +6, 1 */
	unsigned char  psr;		/* +7, 1 */
} M6502REG;				/* =8 */

extern M6502CPU m6502cpu;		/* RAMɔzu */
extern unsigned char m6502mem[0x10000];	/*    SRAMɔzu */

/****************************************************************************
 *	֐
 ****************************************************************************/

int/*%data*/ m6502mem_read(/*%addr*/);	/* Pȃǂݏo[` */
void  m6502mem_write(/*%addr,%data*/);	/* Pȃ݃[` */

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* TODO:  */
/* TODO: Onh̐Bread̖߂lD31:80K{!! */

void m6502cpu_reset(void* read, void* write);
void m6502cpu_run(int cycle);
void m6502cpu_irq();
void m6502cpu_nmi();
void m6502reg_put(const M6502REG* reg);
void m6502reg_get(M6502REG* reg);

#endif /*__CLIP_65C_H__*/
