/*
 *	fram.c
 *
 *	Famicom/EMU
 *
 *	* Thu Feb 03 00:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

// int/*%data*/ famicom_read(/*%addr*/)
asm("
	.code
	.align	2
	.global	famicom_read
famicom_read:
	xcmp	%r0, 0x2000
	xjrlt	m6502mem_read	; RAM
	xcmp	%r0, 0x7fff
	xjrgt	m6502mem_read	; PRG-ROM
	;
	xcall	m6502cpu_leave
	xcall.d	famicom_read_io
	ld.w	%r12, %r0	; %r12 <- %addr
	xjp.d	m6502cpu_enter
	ld.w	%r1, %r10	; %r10 -> %data
");

int
famicom_read_io(int addr)
{
	if(addr >= 0x2000 && addr <= 0x2007) {
		/* VBlankASprite#0 HitĎ[ṽG~[V邽߂ɁA
		 * StatusWX^̓ǂݏoő1line̎Ԃ邱Ƃɂ܂B
		 * ʂȖ߂̃G~[Vs񐔂炷߂łB
		 * ({StatusWX^ǂݏoɂ́AȃEFCg͗L܂)
		 */
		if(addr == 0x2002) {
			/* NTSCJ[TuLANbN(3.58MHz)ŁA1line=228A
			 * t@~RCPUNbN1.79MHzȂ̂ŁA̔łB
			 */
			m6502cpu.cycle -= 228 / 2;
		}
		return ppu_read(addr);
	}
	if(addr == 0x4016) {
		input_shift >>= 1;
		return input_shift & 1;
	}
	return m6502mem[addr];
}

/****************************************************************************
 *	
 ****************************************************************************/

// void famicom_write(/*%addr,%data*/)
asm("
	.code
	.align	2
	.global	famicom_write
famicom_write:
	xcmp	%r0, 0x2000
	xjrlt	m6502mem_write	; RAM
	;
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0	; %r12 <- %addr
	xcall.d	famicom_write_io
	ld.w	%r13, %r1	; %r13 <- %data
	xjp	m6502cpu_enter
");

void
famicom_write_io(int addr, int data)
{
	if(addr >= 0x2000 && addr <= 0x2007) {
		ppu_write(addr, data);
		return;
	}
	if(addr == 0x4014) { /* Sprite DMA */
		memcpy(ppu_sprram, &m6502mem[data << 8], 0x100);
		return;
	}
	if(addr == 0x4016) { /* Input Strobe */
		/* { { [$4016]=1; [$4016]=0 } ̎菇StrobêłǁA
		 * ɃyAŎsƉ肵AStrobe邱Ƃɂ܂B
		 */
		input_shift = input << 1;
		return;
	}
	if(addr >= 0x8000) { /* Mapper? */
		if(mapper->write) {
			mapper->write(addr, data);
		}
		return;
	}
	m6502mem[addr] = data;
}

