/*
 *	mapper.c
 *
 *	Famicom/EMU
 *
 *	* Thu Feb 03 00:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static int prgrom_bank[2];
static int chrrom_bank[1];

/****************************************************************************
 *	
 ****************************************************************************/

static int init00() {
	if(ines->prgrom_page_count < 1) return -1;
	if(ines->chrrom_page_count < 1) return -1;

	prgrom_bank[0] = 0 % ines->prgrom_page_count;
	memcpy(&m6502mem[0x8000], prgrom[prgrom_bank[0]], 0x4000);

	prgrom_bank[1] = 1 % ines->prgrom_page_count;
	memcpy(&m6502mem[0xc000], prgrom[prgrom_bank[1]], 0x4000);

	chrrom_bank[0] = 0 % ines->chrrom_page_count;
	memcpy(&ppu_vram[0x0000], chrrom[chrrom_bank[0]], 0x2000);

	return 0;
}

static const MAPPER mapper00 = { init00, NULL };

/****************************************************************************
 *	
 ****************************************************************************/

static int init03() {
	if(ines->prgrom_page_count < 1) return -1;
	if(ines->chrrom_page_count < 1) return -1;

	prgrom_bank[0] = 0 % ines->prgrom_page_count;
	memcpy(&m6502mem[0x8000], prgrom[prgrom_bank[0]], 0x4000);

	prgrom_bank[1] = 1 % ines->prgrom_page_count;
	memcpy(&m6502mem[0xc000], prgrom[prgrom_bank[1]], 0x4000);

	chrrom_bank[0] = 0 % ines->chrrom_page_count;
	memcpy(&ppu_vram[0x0000], chrrom[chrrom_bank[0]], 0x2000);

	return 0;
}

static void write03(int addr, int data) {
	data %= ines->chrrom_page_count;
	if(chrrom_bank[0] != data) {
		chrrom_bank[0] = data;
		memcpy(&ppu_vram[0x0000], chrrom[chrrom_bank[0]], 0x2000);
	}
}

static const MAPPER mapper03 = { init03, write03 };

/****************************************************************************
 *	
 ****************************************************************************/

const MAPPER* const mapper_list[256] = {
/*00*/	&mapper00,
/*01*/	NULL,
/*02*/	NULL,
/*03*/	&mapper03,
};
